diff --git a/web/test/integration/daemon_health_test.rb b/web/test/integration/daemon_health_test.rb
new file mode 100644
index 00000000..851e6e9f
--- /dev/null
+++ b/web/test/integration/daemon_health_test.rb
@@ -0,0 +1,84 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/pid_file"
+
+class DaemonHealthTest < ActionDispatch::IntegrationTest
+  include Hive::PidFile
+
+  def pid_file
+    File.join(Hive::Paths.state_home, ".daemon.pid")
+  end
+
+  setup do
+    sign_in!
+  end
+
+  test "status page shows banner when daemon is down" do
+    FileUtils.rm_f(pid_file)
+    get root_path
+    assert_response :success
+    assert_match(/Daemon is not running/, response.body)
+    assert_match(/daemon-health-banner/, response.body)
+  end
+
+  test "status page hides banner when daemon is live" do
+    FileUtils.mkdir_p(File.dirname(pid_file))
+    File.write(pid_file, pid_file_payload(Process.pid).to_yaml)
+    get root_path
+    assert_response :success
+    refute_match(/Daemon is not running/, response.body)
+  ensure
+    FileUtils.rm_f(pid_file)
+  end
+
+  test "deep health includes version and drift fields" do
+    FileUtils.rm_f(pid_file)
+    get "/health", params: { deep: "1" }
+    assert_response :service_unavailable
+    body = response.parsed_body
+    assert_equal false, body.dig("daemon", "running")
+    assert body["daemon"].key?("version")
+    assert body["daemon"].key?("drifted")
+    assert_equal Hive::VERSION, body.dig("daemon", "cli_version")
+  end
+
+  test "deep health running still includes drift fields" do
+    FileUtils.mkdir_p(File.dirname(pid_file))
+    File.write(pid_file, pid_file_payload(Process.pid).to_yaml)
+    get "/health", params: { deep: "1" }
+    assert_response :success
+    body = response.parsed_body
+    assert_equal true, body.dig("daemon", "running")
+    assert body["daemon"].key?("drifted")
+    assert_equal Process.pid, body.dig("daemon", "pid")
+  ensure
+    FileUtils.rm_f(pid_file)
+  end
+
+  test "POST daemon start with stubbed spawn success" do
+    FileUtils.rm_f(pid_file)
+    original = DaemonController.instance_method(:spawn_hive)
+    DaemonController.define_method(:spawn_hive) do |_args|
+      { ok: true, detail: "ok" }
+    end
+    post daemon_start_path
+    assert_response :redirect
+    follow_redirect!
+    assert_match(/Daemon start requested/, flash[:notice].to_s + response.body)
+  ensure
+    DaemonController.define_method(:spawn_hive, original)
+  end
+
+  test "POST daemon start failure surfaces error" do
+    original = DaemonController.instance_method(:spawn_hive)
+    DaemonController.define_method(:spawn_hive) do |_args|
+      { ok: false, detail: "boom stderr" }
+    end
+    post daemon_start_path
+    assert_response :redirect
+    assert_match(/boom stderr/, flash[:notice].to_s)
+  ensure
+    DaemonController.define_method(:spawn_hive, original)
+  end
+end
diff --git a/web/test/integration/local_auth_mode_test.rb b/web/test/integration/local_auth_mode_test.rb
new file mode 100644
index 00000000..daee7ef7
--- /dev/null
+++ b/web/test/integration/local_auth_mode_test.rb
@@ -0,0 +1,59 @@
+# frozen_string_literal: true
+
+require "test_helper"
+
+class LocalAuthModeTest < ActionDispatch::IntegrationTest
+  test "auth mode none loads grid without session" do
+    with_auth_mode("none") do
+      get root_path
+      assert_response :success
+      assert_match(/local/, response.body)
+    end
+  end
+
+  test "auth mode none redirects login to root" do
+    with_auth_mode("none") do
+      get login_path
+      assert_redirected_to root_path
+    end
+  end
+
+  test "auth mode none rejects non-loopback host" do
+    with_auth_mode("none") do
+      get root_path, headers: { "Host" => "evil.example" }
+      assert_response :forbidden
+    end
+  end
+
+  test "auth mode github still requires login" do
+    with_auth_mode("github") do
+      get root_path
+      assert_redirected_to login_path
+    end
+  end
+
+  test "auth mode unset defaults to github" do
+    with_auth_mode(nil) do
+      get root_path
+      assert_redirected_to login_path
+    end
+  end
+
+  private
+
+  def with_auth_mode(mode)
+    previous = ENV["HIVEBOX_AUTH_MODE"]
+    if mode.nil?
+      ENV.delete("HIVEBOX_AUTH_MODE")
+    else
+      ENV["HIVEBOX_AUTH_MODE"] = mode
+    end
+    yield
+  ensure
+    if previous.nil?
+      ENV.delete("HIVEBOX_AUTH_MODE")
+    else
+      ENV["HIVEBOX_AUTH_MODE"] = previous
+    end
+  end
+end
